<?php
/**
 * @package n3tTemplate
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2012 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.version' );

class plgN3tTemplateDJImageSlider extends JPlugin
{

	function plgN3tTemplateDJImageSlider(& $subject, $config)
	{
		parent::__construct($subject, $config);
    $this->loadLanguage('', JPATH_ADMINISTRATOR); 		
	}

	function onN3tTemplateItems( $plugin, & $items, $params ) {
	  if ($plugin == $this->_name) {
	    if (!is_object($params)) $params = $this->params;
  	  $db =& JFactory::getDBO();
        
      $limit=(int)$params->def('max_results', '');
      $limit = $limit ? $limit=' LIMIT 0,'.$limit : '';
      $published = $params->def('only_published', 0) ? ' AND published=1' : '';
      switch($params->def('ordering', 'idasc')) {
        case 'idasc':
        default:
          $ordering = 'id ASC';
          break;
        case 'iddesc':
          $ordering = 'id DESC';
          break;           
        case 'titleasc':
          $ordering = 'title ASC, id ASC';
          break;           
        case 'titledesc':
          $ordering = 'title DESC, id DESC';
          break;           
      }
      if (JVersion::isCompatible('1.6.0')) {
        $db->setQuery('SELECT DISTINCT id, title, '.
          '(SELECT count(id) FROM  #__categories c2 WHERE c1.id=c2.parent_id) AS children'.
          ' FROM #__categories c1 WHERE extension="com_djimageslider"'.
          $published.' and parent_id='.JRequest::getVar('id',1).
          ' ORDER BY '.$ordering.$limit);
      } else {
        $db->setQuery('SELECT DISTINCT id, title, 0 AS children'.
          ' FROM #__categories c1 WHERE section="com_djimageslider"'.
          $published.' ORDER BY '.$ordering.$limit);
      }

      $categories = $db->loadObjectList();
      
      if ($categories) { 
  	    foreach ($categories as $category) { 
  	      $item = new stdClass();
          $item->title=$category->title; 
          $item->url='id='.$category->id;
          $item->category=(bool)$category->children;
          $items[] = $item;
        }	              
        return true;
      } 
	  }	  
	  return false;
	}
	
	function onN3tTemplateTemplate( $plugin, & $template, $params ) {
	  if ($plugin == $this->_name) {
	    if (!is_object($params)) $params = $this->params;
	    $db =& JFactory::getDBO();
	    $db->setQuery('SELECT id, title, alias FROM #__categories WHERE id='.JRequest::getInt('id'));
	    $category = $db->loadObject();
	    if ($category) {
  	    switch ($params->def('output', 'djimageslider')) {
  	      case 'djimageslider':
  	        $template = '{djimageslider}'.$category->id.'{/djimageslider}';
  	        break;
  	      case 'djimagetabber':
  	        $template = '{djimagetabber}'.$category->id.'{/djimagetabber}';
  	        break;
  	      case 'custom':
  	        $template = $params->def('custom_output', '');
        		$search = array(
  	         '%ID%',
  	         '%ALIAS%',
  	         '%TITLE%'
            );    	
        		$replace = array(
        		  $category->id,
        		  $category->alias,
        		  $category->title
        		);                      
        		$template = str_replace($search, $replace, $template);            
            break; 
  	    }	    
        return true;
      } 
	  }	  
	  return false;
	}

}